#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <ctime>
#include <cassert>
#include <iostream>
#include <utility>
#include <functional>
#include <vector>
#include <queue>
#include <stack>
#include <string>
#include <set>
#include <map>
#include <list>
#include <algorithm>
#include <random>
using namespace std;

typedef long long lld;
typedef pair<int, int> ii;

#define fastio() ios::ios_base::sync_with_stdio(false); setbuf(stdout, 0); cin.tie(false)
#define FOR(i, n) for(int i=0; i<(n); ++i)
#define all(v) (v).begin(),(v).end()

const int INF = 0x3f3f3f3f;
const lld LINF = 0x3f3f3f3f3f3f3f3f;
const int MOD = 1e9 + 7;

static int dy[] = {-1,0,1,0};
static int dx[] = {0,1,0,-1};

bool v[50][50][1 << 5];
char g[50][51];

struct state {
    int y, x, bit;
};

int main() {
    int h, w, tc = 0;
    FILE *fin, *fout;
    while (~scanf("%d %d", &w, &h)) {
        memset(g, 0, sizeof(g));
        memset(v, 0, sizeof(v));

        char buf[55];
        sprintf(buf, "%d.in", ++tc);
        fin = fopen(buf, "w");
        sprintf(buf, "%d.out", tc);
        fout = fopen(buf, "w");

        int stuffs = 0;
        queue<state> q;
        fprintf(fin, "%d %d\n", w, h);
        FOR(i, h) {
            scanf("%s ", g[i]);
            fputs(g[i], fin);
            FOR(j, w) {
                if (g[i][j] == 'X') g[i][j] = '0' + (stuffs++);
                if (g[i][j] == 'S') {
                    q.push({i, j, 0});
                    v[i][j][0] = true;
                }
            }
        }

        int ans = 0;
        while (!q.empty()) {
            int qs = q.size();
            bool find = false;
            while (qs--) {
                int y = q.front().y;
                int x = q.front().x;
                int b = q.front().bit;
                q.pop();

                if (b == (1 << stuffs) - 1 && g[y][x] == 'E') {
                    find = true;
                    break;
                }

                FOR(i, 4) {
                    int ny = y + dy[i];
                    int nx = x + dx[i];
                    if (ny < 0 || ny >= h || nx < 0 || nx >= w) continue;

                    char ch = g[ny][nx];
                    int nb = b;
                    if ('0' <= ch && ch <= '9') {
                        nb = b | (1 << (ch - '0'));
                    }
                    if (ch == '#' || v[ny][nx][nb]) continue;
                    v[ny][nx][nb] = true;
                    q.push({ny, nx, nb});
                }
            }
            if (find) break;
            ++ans;
        }
        while (!q.empty()) q.pop();
        fprintf(fout, "%d\n", ans);

        fclose(fin);
        fclose(fout);
    }

    return 0;
}